#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct varr_s {	int	argc;
			char	*argv[1]; } varr_t;


char *qstrtok (char *buf, char *pat, char **context, char *quotes)
{
    char *ptr = NULL, *result;

    if (context  == NULL) return (NULL);
    if (*pat == '\0') return (*context=NULL);
    if (buf != NULL) *context = buf;
    if ((result = *context) == NULL) return (NULL);

    for (; *result != '\0'; result++)
	if (strchr(pat,(int)*result) == NULL) break;

    if (*result == '\0') return (*context=NULL);

    for (; *quotes != '\0'; quotes++)
	if (*result == *quotes) {
            if (*(++quotes) != '\0') {
                if (*(++result) == '\0') return (*context=NULL);
                    ptr = strchr(result, (int)(*quotes));
            }
            break;
        }

    if (*quotes == '\0')
        ptr = strpbrk(result, pat);

    if (ptr != NULL) *ptr++ = '\0';
    *context = ptr;

    return(result);
}


void vecFree(varr_t **vecp)
{
    varr_t *vec;
    int i;

    if ((vecp != NULL) && ((vec = *vecp) != NULL)) {
        for (i = 0; i < vec->argc; i++)
            if (vec->argv[i] != NULL)
                free(vec->argv[i]);
        free(vec);
        *vecp = NULL;
    }
}


varr_t *vecAlloc(char *token, int count, char *sep, char *quot, char **ctx)
{
    varr_t *res;

    printf ("%s: token: %s   count: %d\n", __FUNCTION__, token, count);

    if (token == NULL) {
        if ((res = (varr_t *)malloc(sizeof(varr_t) + 
                                   (count * sizeof(char*)))) != NULL) {
            printf ("%s: array size: %d\n", __FUNCTION__, sizeof(varr_t) + 
                                   (count * sizeof(char*)));
            res->argc = count;
            res->argv[count] = NULL;
        }
    }
    else {
        if ((res = vecAlloc(qstrtok(NULL,sep,ctx,quot), count+1,
                            sep, quot, ctx)) != NULL) {
            if ((res->argv[count] = strdup(token)) == NULL)
                vecFree(&res);
            if (!strcmp(token,"999"))
                vecFree(&res);            
        }
    }
    return res;
}


varr_t *cutLine(char *line)
{
    static char *sep = " \t", *quot = "''''";
    char *ctx;
    return vecAlloc(qstrtok(line,sep,&ctx,quot), 0, sep, quot, &ctx);
}



int main (int argc, char **argv)
{
    varr_t *res;
    int i;

    res = cutLine(argv[1]);
    printf("%p\n", res);
    if (res != NULL) {
        printf("%d\n", res->argc);
        for (i=0; i<=(argc+1); i++)
            printf("[%s]\n",res->argv[i]);
    }
    return 0;
}
